* MAINTENANCE PROGRAM REGISTER.PRG

* Application: Hak Cipta 1999  Amsal Djunid
* Date:        06/25/99    Time: 14:29:01

PROCEDURE REGISTER

* DATABASE FILES
  dbf1 = 'REGISTER'
  alias1 = 'registera'
  dbf_descr1 = 'Catatan Induk Buku'

  dbf2 = 'BUKU'
  alias2 = 'bukua'
  dbf_descr2 = 'Catatan unik masing-masing bku'

  dbf3 = 'BIDANG'
  alias3 = 'bidanga'
  dbf_descr3 = 'bidang ilmu'

  dbf4 = 'JENIS'
  alias4 = 'jenisa'
  dbf_descr4 = 'jenis koleksi'

* CONTROL VARIABLES
  has_calcul = .F.
  has_disfld = .T.
  has_lookup = .T.
  modify_key = .F.
  no_dbfs = 4
  no_pages = 2
  no_zooms = 2

* ENVIRONMENT
  set bell off
  set deleted on
  set exact off
  set heading off
  set color to w+/b,w+/n,b

* DATABASE 1: REGISTER
  * Field variables
  bahasa = space(3)
  bulan = 0
  edisi = 0
  exemplar = 0
  judul = space(30)
  judul2 = space(30)
  judul3 = space(30)
  katalog = space(20)
  kodebidang = space(2)
  kodejenis = space(2)
  kota = space(20)
  no_reg = 0
  penerbit = space(20)
  tahun = 0
  tahun_terb = 0
  tgl = 0
  has_memo1 = .F.
  * Related variables
  allow_dup1 = .F.
  at_bof1 = 'bof()'
  at_eof1 = 'eof()'
  filter_it1 = .T.
  lnk_var1 = ''
  lst_flds1 = "str(no_reg,5,0)+' '+str(tgl,2,0)+' '+str(bulan,2,0)+' '+str(tahun,2,0)+' '+katalog+' '+kodebidang+' '+judul+' '+str(edisi,2,0)+' '+str(tahun,2,0)"
  lst_hdr1 = "NO_RE TG BU TA KATALOG              KO JUDUL                          ED TA"
  ndx_var1 = 'str(m->no_reg,5)'
  page_seq1 = '1'

* DATABASE 2: BUKU
  * Field variables
  no_buku = space(5)
  no_reg = 0
  has_memo2 = .F.
  * Related variables
  allow_dup2 = .F.
  at_bof2 = '(no_reg < m->no_reg .or. bof() )'
  at_eof2 = '(no_reg > m->no_reg .or. eof() )'
  filter_it2 = .T.
  lnk_var2 = 'str(m->no_reg,5)'
  lst_flds2 = "no_buku"
  lst_hdr2 = "NO_BU"
  ndx_var2 = 'str(m->no_reg,5) + m->no_buku'
  page_seq2 = '2'

* DATABASE 3: BIDANG
  * Field variables
  kodebidang = space(2)
  namabidang = space(20)
  * Related variables
  lst_flds3 = "kodebidang+' '+namabidang"
  lst_hdr3 = "Kode BIDANG ILMU         "

* DATABASE 4: JENIS
  * Field variables
  kodejenis = space(2)
  namajenis = space(20)
  * Related variables
  lst_flds4 = "kodejenis+' '+namajenis"
  lst_hdr4 = "Kode   JENIS KOLEKSI          "

* VARIABLES

* WORK VARIABLES
  abort      = .F.
  at_bof     = at_bof1
  at_eof     = at_eof1
  bot_mark   = -1
  choice     = ''
  duplicate  = .F.
  empty      = .F.
  eof_save   = ''
  files_ok   = .T.
  filter_str = ''
  first_page = int(val(substr(page_seq1,1,1)))
  last_page  = int(val(substr(page_seq1,len(page_seq1),1)))
  lnk_var    = ''
  ndx_var    = ndx_var1
  occurs     = .F.
  option     = ''
  page_no    = 1
  rec_count  = 0
  record_no  = 0
  redisp_scr = .T.
  redisp_fld = .F.
  top_mark   = 0
  valid      = .T.
  zoom_num   = '1'
  zoom_no    = 1

  filter_on1 = .F.
  pack_it1   = .F.
  filter_on2 = .F.
  pack_it2   = .F.

* SCREEN
  do disscr

* OPEN FILES
  do chkfil
  if .not. files_ok
    return
  endif
  select 1
  use REGISTER index REGISTER alias registera
  select 2
  use BUKU index BUKU,BUKUPINJ alias bukua
  select 3
  use BIDANG index BIDANG alias bidanga
  select 4
  use JENIS index JENIS alias jenisa
  select 1
  record_no = recno()
  * database is empty if eof() = .T.
  empty = eof()
  if empty
    choice = 'Y'
    do get_optn with 'Database empty; add records (Y/N)', 'YN', choice
    if choice = 'N'
      close databases
      return
    endif
  endif

  * PROCESSING LOOP
  do while zoom_no > 0
    record_no = recno()
    do disscr
    if empty
      * Force Add if database empty
      option = 'A'
    else
      option = 'M'
      * Load and display record
      do load
      do lookup
      do disp_rec
    endif
    if zoom_no = no_zooms
      do get_optn with 'Ret/Beg/End/Next/Prev/Skip/Modi/Add/Copy/Del/' +;
        'List/Filt/Tally/Help/Quit', 'RBENPSMACDLFTHQ', option
    else
      do get_optn with 'Zoom/Ret/Beg/End/Next/Prev/Skip/Modi/Add/Copy/Del/' +;
        'List/Filt/Tally/Help/Quit', 'ZRBENPSMACDLFTHQ', option
    endif
    * Reset to first page for options ACRDFZQ
    if page_no <> first_page .and. option $ 'ACRDFZQ'
      page_no = first_page
      redisp_scr = .T.
      if .not. option $ 'ZQ'
        do disscr
        do disp_rec
      endif
    endif

    do case
    * Add
      case option = 'A'
        do inifld
        do add_rec
    * Beginning
      case option = 'B'
        do go_top
    * Copy
      case option = 'C'
        do add_rec
    * Delete
      case option = 'D'
        do del_rec
    * End
      case option = 'E'
        do go_bot
    * Filter
      case option = 'F'
        if filter_it&zoom_num
          do filter
        else
          do disp_msg with 'Database has no filter fields'
        endif
    * Help
      case option = 'H'
        set color to w+/gr+
        do mnt_help
        set color to w+/b,w+/n,b
        redisp_scr = .T.
    * List
      case option = 'L'
        do list with lst_flds&zoom_num, lst_hdr&zoom_num, filter_on&zoom_num
        go record_no
        redisp_scr = .T.
    * Modify
      case option = 'M'
        do modify
    * Next
      case option = 'N'
        skip
        if &at_eof
          do go_bot
          do disp_msg with chr(7) + 'Last record'
        endif
    * PgDn
      case option = '-'
        if page_no > first_page
          page_no = page_no - 1
          redisp_scr = .T.
        endif
    * PgUp
      case option = '+'
        if page_no < last_page
          page_no = page_no + 1
          redisp_scr = .T.
        endif
    * Previous
      case option = 'P'
        skip -1
        if &at_bof
          do go_top
          do disp_msg with chr(7) + 'First record'
        endif
    * Retrieve
      case option = 'R'
        do retrieve
    * Skip
      case option = 'S'
        * Move forward/backward several records
        rec_count = 0
        @ 23,70 say '  Recs' get rec_count picture '@Z 999'
        read
        skip rec_count
        if &at_eof
          do go_bot
          do disp_msg with chr(7) + 'Last Record'
        endif
        if &at_bof
         do go_top
         do disp_msg with chr(7) + 'First record'
        endif
    * Tally
      case option = 'T'
        * Count and display number of records in database
        @ 23,00
        @ 23,00 say 'Counting, please wait'
        rec_count = 0
        do go_top
        count while .not. &at_eof to rec_count
        do disp_msg with 'Count: ' + str(rec_count,6) + ' records'
        go record_no
    * Zoom
      case option = 'Z'
        zoom_no = zoom_no + 1
        do zoom
        do go_top
        empty = &at_eof
    endcase

    * Quit
    if option = 'Q'
      zoom_no = zoom_no - 1
      if zoom_no > 0
        do zoom
        go record_no
        redisp_scr = .T.
        empty = .F.
      endif
    endif

  enddo while zoom_no > 0
  do pack_dbf
  close databases
return

* SPECIFIC PROCEDURES (listed alphabetically)

procedure chkfil
* Verify that all the database files accessed by the program exist.
* If a database file is missing, set files_ok to .F. and display a message.
* If they all exist, check their index files, and create any that are missing.
  close databases
  if .not. file ('REGISTER.DBF')
    do disp_msg with 'File REGISTER.DBF not found'
    files_ok = .F.
  endif
  if .not. file ('BUKU.DBF')
    do disp_msg with 'File BUKU.DBF not found'
    files_ok = .F.
  endif
  if .not. file ('BIDANG.DBF')
    do disp_msg with 'File BIDANG.DBF not found'
    files_ok = .F.
  endif
  if .not. file ('JENIS.DBF')
    do disp_msg with 'File JENIS.DBF not found'
    files_ok = .F.
  endif
  * Index if index file missing
  if files_ok
    if .not. file ('REGISTER.NDX')
      @ 23,00
      @ 23,00 say 'Creating index REGISTER'
      use REGISTER
      index on str(no_reg,5) to REGISTER
      use
    endif
    if .not. file ('BUKU.NDX')
      @ 23,00
      @ 23,00 say 'Creating index BUKU'
      use BUKU
      index on str(no_reg,5) + no_buku to BUKU
      use
    endif
    if .not. file ('BUKUPINJ.NDX')
      @ 23,00
      @ 23,00 say 'Creating index BUKUPINJ'
      use BUKU
      index on no_buku to BUKUPINJ
      use
    endif
    if .not. file ('BIDANG.NDX')
      @ 23,00
      @ 23,00 say 'Creating index BIDANG'
      use BIDANG
      index on kodebidang to BIDANG
      use
    endif
    if .not. file ('JENIS.NDX')
      @ 23,00
      @ 23,00 say 'Creating index JENIS'
      use JENIS
      index on kodejenis to JENIS
      use
    endif
  endif
return

procedure clrfld
parameters initialize
* Clear all screen field areas; if init_fld = .T., also initialize fields
  do case
    case page_no = 1
      @ 6,29 say space(5)
      @ 6,47 say space(2)
      @ 6,52 say space(2)
      @ 6,57 say space(2)
      @ 8,18 say space(19)
      @ 8,52 say space(2)
      @ 8,55 say space(20)
      @ 10,10 say space(30)
      @ 11,10 say space(30)
      @ 12,10 say space(30)
      @ 12,52 say space(2)
      @ 14,13 say space(20)
      @ 14,43 say space(4)
      @ 14,56 say space(20)
      @ 16,16 say space(3)
      @ 16,30 say space(3)
      @ 16,42 say space(2)
      @ 16,46 say space(20)
      if initialize
        no_reg = 0
        tgl = 0
        bulan = 0
        tahun = 0
        katalog = space(20)
        kodebidang = space(2)
        judul = space(30)
        judul2 = space(30)
        judul3 = space(30)
        edisi = 0
        penerbit = space(20)
        tahun_terb = 0
        kota = space(20)
        exemplar = 0
        bahasa = space(3)
        kodejenis = space(2)
      endif
    case page_no = 2
      @ 20,28 say space(5)
      if initialize
        no_buku = space(5)
      endif
  endcase
return

procedure clrsay
* Clear database fields and variable field areas
  do case
    case page_no = 1
      @ 8, 55 say space(20)
      @ 16, 46 say space(20)
    case page_no = 2
  endcase
return

procedure disfld
* Display database and variables fields
  do case
    case page_no = 1
      @ 8, 55 get m->namabidang picture '@!'
      @ 16, 46 get m->namajenis picture '@!'
    case page_no = 2
  endcase
  clear gets
return

procedure disscr
* Display stationary part of the screen page (only if redisp_scr = .T.)
  if .not. redisp_scr
    return
  endif
  clear
  set color to r+/b
  do scr_box with 'Hak Cipta 1999  Amsal Djunid', 'Perpustakaan'
  set color to w+/b,w+/n,b
  do case
    case page_no = 1
      @  4,25 say 'Memcatat Katalog Buku'
      @  6,12 say 'Nomor Register :         Tanggal :    /    /'
      @  8, 2 say 'Nomor Katalog :                     Bidang Ilmu :'
      @ 10, 2 say 'Judul :'
      @ 12,44 say 'Edisi :'
      @ 14, 2 say 'Penerbit :                       Tahun :       Kota :'
      @ 16, 9 say 'Exemp:      Bahasa :      Jenis:'
      @ 18,15 say 'Tekan Z untuk Mencatat Nomor Masing-masing Buku'
      @ 20,15 say 'Nomor Buku :'
    case page_no = 2
      @ 20,15 say 'Nomor Buku :'
  endcase
  if filter_on&zoom_num
    @ 0,70 say 'Filter On'
  else
    @ 0,70 say space(9)
  endif
  redisp_scr = .F.
  redisp_fld = .T.
return

procedure filter
* Set filter on database
  choice = 'Q'
  do get_optn with 'Filter: Set/Cancel/Quit','SCQ',choice
  if choice = 'S'
    do clrfld with .T.
    filter_str = ''
    * Get filter fields
    do case
      case zoom_no = 1
        @ 6, 29 get m->no_reg picture '99999'
        @ 6, 47 get m->tgl picture '99'
        @ 6, 52 get m->bulan picture '99'
        @ 6, 57 get m->tahun picture '99'
        @ 8, 18 get m->katalog
        @ 8, 52 get m->kodebidang
        @ 10, 10 get m->judul picture '@!'
        @ 14, 13 get m->penerbit picture '@!'
        @ 14, 43 get m->tahun_terb picture '9999'
        @ 16, 30 get m->bahasa picture '@!'
        @ 16, 42 get m->kodejenis
      case zoom_no = 2
        @ 20, 28 get m->no_buku picture '99999'
    endcase
    read
    if readkey() <> 12  && Esc
      * Form filter string
      do case
        case zoom_no = 1
          if 0 <> m->no_reg
            no_reg = str(m->no_reg,5,0)
            filter_str = filter_str + "no_reg=&no_reg .and."
          endif
          if 0 <> m->tgl
            tgl = str(m->tgl,2,0)
            filter_str = filter_str + "tgl=&tgl .and."
          endif
          if 0 <> m->bulan
            bulan = str(m->bulan,2,0)
            filter_str = filter_str + "bulan=&bulan .and."
          endif
          if 0 <> m->tahun
            tahun = str(m->tahun,2,0)
            filter_str = filter_str + "tahun=&tahun .and."
          endif
          if '' <> trim(m->katalog)
            filter_str = filter_str + "katalog='"+trim(m->katalog)+"' .and."
          endif
          if '' <> trim(m->kodebidang)
            filter_str = filter_str + "kodebidang='"+trim(m->kodebidang)+"' .and."
          endif
          if '' <> trim(m->judul)
            filter_str = filter_str + "judul='"+trim(m->judul)+"' .and."
          endif
          if '' <> trim(m->penerbit)
            filter_str = filter_str + "penerbit='"+trim(m->penerbit)+"' .and."
          endif
          if 0 <> m->tahun_terb
            tahun = str(m->tahun_terb,4,0)
            filter_str = filter_str + "tahun_terb=&tahun_terb .and."
          endif
          if '' <> trim(m->bahasa)
            filter_str = filter_str + "bahasa='"+trim(m->bahasa)+"' .and."
          endif
          if '' <> trim(m->kodejenis)
            filter_str = filter_str + "kodejenis='"+trim(m->kodejenis)+"' .and."
          endif
        case zoom_no = 2
          if '' <> trim(m->no_buku)
            filter_str = filter_str + "no_buku='"+trim(m->no_buku)+"' .and."
          endif
      endcase
    endif readkey() <> 12  && Esc
    if '' = trim(filter_str)
      set filter to
      filter_on&zoom_num = .F.
    else
      filter_str = substr(filter_str,1,len(filter_str)-6)
      set filter to &filter_str
      do go_top
      filter_on&zoom_num = .not. &at_eof
      if .not. filter_on&zoom_num
        do disp_msg with 'No records match the filter'
        set filter to
        go record_no
      endif
    endif '' = trim(filter_str)
  endif choice = 'S'
  if choice = 'C'
    set filter to
    filter_on&zoom_num = .F.
  endif choice = 'C'
  if filter_on&zoom_num
    @ 0,70 say 'Filter On'
  else
    @ 0,70 say space(9)
  endif
return

procedure getfld
* Get field variables
  do case
    case page_no = 1
      @ 6, 47 get m->tgl picture '99'
      @ 6, 52 get m->bulan picture '99'
      @ 6, 57 get m->tahun picture '99'
      @ 8, 18 get m->katalog
      @ 8, 52 get m->kodebidang
      @ 10, 10 get m->judul picture '@!'
      @ 11, 10 get m->judul2 picture '@!'
      @ 12, 10 get m->judul3 picture '@!'
      @ 12, 52 get m->edisi picture '99'
      @ 14, 13 get m->penerbit picture '@!'
      @ 14, 43 get m->tahun_terb picture '9999'
      @ 14, 56 get m->kota picture '@!'
      @ 16, 16 get m->exemplar picture '999'
      @ 16, 30 get m->bahasa picture '@!'
      @ 16, 42 get m->kodejenis
    case page_no = 2
  endcase
return

procedure getkey
* Get key variables
  do case
    case page_no = 1
      @ 6, 29 get m->no_reg picture '99999'
    case page_no = 2
      @ 20, 28 get m->no_buku picture '99999'
  endcase
return

procedure inifld
* Initilize field variables
  do case
    case zoom_no = 1
      no_reg = 0
      tgl = 0
      bulan = 0
      tahun = 0
      katalog = space(20)
      kodebidang = space(2)
      namabidang = space(20)
      judul = space(30)
      judul2 = space(30)
      judul3 = space(30)
      edisi = 0
      penerbit = space(20)
      tahun_terb = 0
      kota = space(20)
      exemplar = 0
      bahasa = space(3)
      kodejenis = space(2)
      namajenis = space(20)
    case zoom_no = 2
      no_buku = space(5)
  endcase
return

procedure load
* Copy fields from database record to memory variables
  do case
    case zoom_no = 1
      bahasa = bahasa
      bulan = bulan
      edisi = edisi
      exemplar = exemplar
      judul = judul
      judul2 = judul2
      judul3 = judul3
      katalog = katalog
      kodebidang = kodebidang
      kodejenis = kodejenis
      kota = kota
      no_reg = no_reg
      penerbit = penerbit
      tahun = tahun
      tahun_terb = tahun_terb
      tgl = tgl
    case zoom_no = 2
      no_buku = no_buku
      no_reg = no_reg
  endcase
return

procedure lookup
* Load lookup fields
  * Database BIDANG
  if zoom_no = 1
    select bidanga
    seek m->kodebidang
    namabidang = namabidang
  endif
  * Database JENIS
  if zoom_no = 1
    select jenisa
    seek m->kodejenis
    namajenis = namajenis
  endif
  select &zoom_num
return

procedure replce
* Replace database fields with memory variables
  do case
    case zoom_no = 1
      replace bahasa with m->bahasa
      replace bulan with m->bulan
      replace edisi with m->edisi
      replace exemplar with m->exemplar
      replace judul with m->judul
      replace judul2 with m->judul2
      replace judul3 with m->judul3
      replace katalog with m->katalog
      replace kodebidang with m->kodebidang
      replace kodejenis with m->kodejenis
      replace kota with m->kota
      replace no_reg with m->no_reg
      replace penerbit with m->penerbit
      replace tahun with m->tahun
      replace tahun_terb with m->tahun_terb
      replace tgl with m->tgl
    case zoom_no = 2
      replace no_buku with m->no_buku
      replace no_reg with m->no_reg
  endcase
return

procedure valdte
* Set valid to .F. if a field doesn't pass validation test;
* set abort to .T. or .F., depending on user's response
  valid = .T.
  do case
    case page_no = 1
      * Validate kodebidang against file BIDANG
      select bidanga
      seek m->kodebidang
      if eof()
        valid = .F.
        choice = 'Y'
        do get_optn with ;
          "Kode bidang ilmu salah; display (Y/N)", 'YN', choice
        if choice = 'Y'
          go top
          eof_save = at_eof
          at_eof = 'eof()'
          do list with lst_flds3, lst_hdr3, .F.
          at_eof = eof_save
          select &zoom_num
          redisp_scr = .T.
          do disscr
          do disp_rec
        endif
      endif
      select &zoom_num
      * Validate kodejenis against file JENIS
      select jenisa
      seek m->kodejenis
      if eof()
        valid = .F.
        choice = 'Y'
        do get_optn with ;
          "Kode Jenis Koleksi Salah; display (Y/N)", 'YN', choice
        if choice = 'Y'
          go top
          eof_save = at_eof
          at_eof = 'eof()'
          do list with lst_flds4, lst_hdr4, .F.
          at_eof = eof_save
          select &zoom_num
          redisp_scr = .T.
          do disscr
          do disp_rec
        endif
      endif
      select &zoom_num
    case page_no = 2
  endcase
  abort = .F.
  if .not. valid
    choice = 'Y'
    do get_optn with ;
      'Invalid entries; do you wish to correct (Y/N)', 'YN', choice
    if choice = 'N'
      abort = .T.
    endif
  endif .not. valid
return

* GENERIC PROCEDURES
* GENIFER V2.00 Generic Maintenance Procedures for dBASE III-Plus.
* Copyright (c) 1988 Bytel Corp. Use licensed by Bytel Corp.

procedure add_rec
* Add a record
  abort = .F.
  do while page_no <= last_page
    * Get and validate fields on current page
    do clrfld with .F.
    do getkey
    do getfld
    read
    if readkey() = 12  && Esc
      abort = .T.
      exit
    endif
    if page_no = first_page
      * Check for duplicate (key entered only on first page)
      do chk_dupl
      if duplicate
        abort = .T.
        exit
      endif
    endif
    * Display lookup fields and computed variables
    if has_lookup
      do lookup
    endif
    if has_calcul
      do calcul
    endif
    if has_calcul .or. has_disfld
      do disfld
    endif
    * Check for invalid entries
    do valdte
    if .not. valid
      if abort
        exit
      else
        loop
      endif
    endif
    if page_no < last_page
      * Display next screen page
      page_no = page_no + 1
      redisp_scr = .T.
      do disscr
    else
      exit
    endif
  enddo while page_no <= last_page
  * Restore page number
  if page_no > first_page
    page_no = first_page
    redisp_scr = .T.
  endif
  if .not. abort
    * Save the new record
    do save_rec with .T.
  else
    if empty
      option = 'Q'
    else
      option = 'M'
      if .not. duplicate
        go record_no
      endif
    endif empty
  endif abort
return

procedure chk_dupl
* Set duplicate to .F. if the key is a duplicate, or to .T. otherwise
  if empty .or. '' = trim(ndx_var) .or. allow_dup&zoom_num
    duplicate = .F.
  else
    seek &ndx_var
    if option = 'M'
      duplicate = record_no <> recno() .and. .not. &at_eof
    else
      duplicate = .not. &at_eof
    endif
    if duplicate
      do disp_msg with chr(7) + 'Duplicate record not allowed'
    else
      go record_no
    endif
  endif
return

procedure del_rec
* Delete current record upon user approval
  if zoom_no < no_zooms
    * Are there any children records?
    child_num = str(zoom_no + 1, 1)
    select &child_num
    lnk_var = lnk_var&child_num
    seek &lnk_var
    if .not. &at_eof
      do disp_msg with chr(7) + "Can't delete - subordinate records exist"
      select &zoom_num
      return
    endif
    select &zoom_num
  endif
  choice = 'N'
  do get_optn with 'Delete (Y/N)','YN',choice
  if choice = 'Y'
    delete
    * reposition to the next record
    skip
    * if last record deleted, go to beginning of database
    if &at_eof
      do go_top
    endif
    if &at_eof .and. filter_on&zoom_num
      * no records left in filter, remove the filter
      set filter to
      filter_on&zoom_num = .F.
      @ 0,70 say space(9)
      do go_top
    endif
    if &at_eof
      * Last record deleted, database now empty
      option = 'Q'
    endif
    pack_it&zoom_num = .T.
  endif choice = 'Y'
return

procedure disp_msg
parameters message
* Display MESSAGE + '...' at line 23; wait for entry of any key
* if MESSAGE is blank, make it 'Press any key to continue'
  @ 23,00
  @ 22,0 say ''
  if '' = trim(message)
    wait message + 'Press any key to continue...'
  else
    wait message + '...'
  endif
return

procedure disp_rec
* Display screen page and current record
  do getkey
  do getfld
  clear gets
  if has_calcul .or. has_disfld
    do disfld
  endif
  redisp_fld = .F.
return

procedure get_optn
parameters optn_msg, optn_list, optn_ret
* Display the string optn_msg on line 23; get a character (defaulted to
* to optn_ret, which must be a memory variable, not literal), validate it
* against the list of valid options optn_list and return in optn_ret.
* If optn_ret = 'A' display it without accepting (for forced Add).
* PgUp and PgDn keys return '-' and '+', respectively; Esc key returns 'Q'.
  @ 23,00 say optn_msg + '? '
  @ 23,len(optn_msg)+3
  char = ' '
  do while .not. char $ optn_list + '+-'
    char = optn_ret
    @ 23,len(optn_msg) + 2 get char picture '!'
    if optn_ret <> 'A'
      read
      char = iif (readkey() = 12, 'Q', char)  && Esc
      char = iif (readkey() = 6,  '-', char)
      char = iif (readkey() = 7,  '+', char)
    else
      clear gets
    endif
  enddo
  optn_ret = char
return

procedure go_bot
* Go to last record (last child record if Zoomed)
  if bot_mark >= 0
    go bot_mark
    skip -1
  else
    if bot_mark = -1
      go bottom
    else
      * Find first record outside range
      locate while .T. for &at_eof
      if eof()
        * It is last record in database
        bot_mark = -1
      else
        bot_mark = recno()
      endif
      skip -1
    endif
  endif
return

procedure go_top
  if top_mark = 0
    go top
  else
    go top_mark
    skip
  endif
return

procedure list
parameters lst_flds, header, filter_on
* Displays lst_flds beginning from current record, with header
  do while .T.
    clear
    if filter_on
      ?? space(70) + 'Filter On'
    endif
    ? ' ' + header
    list off next 20 &lst_flds while .not. &at_eof
    if &at_eof
      do disp_msg with ''
      exit
    endif
    choice = 'Y'
    do get_optn with 'More (Y/N)', 'YN', choice
    if choice = 'N'
      exit
    endif
  enddo
return

procedure mnt_help
 * Display help screen
  clear
  @ 4,00
  text
        Add        Add a record to the database
        Beg        Go to the first record
        Del        Delete the record on display
        End        Go to the last record
        List       Display records beginning from current record
        Modify     Edit the current record
        Next       Go to the next record
        Prev       Go to the previous record
        Quit       Terminate current maintenance level
        Ret        Retrieve a record by key
        Skip       Go forward/backward by a number of records
        Tally      Count the records (may be slow if many records)
        Zoom       Zoom in to the next maintenance level
        Esc key    Terminate current maintenance level (same as Quit)
        PgUp key   Go to next screen page, if any
        PgDn key   Go to previous screen page, if any
  endtext
  do scr_box with 'Help', 'Maintenance Options'
  choice = 'Y'
  do get_optn with 'More (Y/N)', 'YN', choice
  if choice = 'N'
    return
  endif
  clear
  @ 06,00
  text
                    Key          Screen editing action
                        
                    -->          Character right
                    <--          Character left
                    up arrow     Previous field
                    down arrow   Next field
                    PgDn, PgUp   Accept screen
                    End          Next word/field
                    Home         Previous word/field
                    Del          Delete character
                    Ins          Insert on/off toggle
                    Esc          Abort screen edit
  endtext
  do scr_box with 'Help', 'Screen Edit Keys'
  do disp_msg with ''
  clear
return

procedure modify
* Modify current record
  abort = .F.
* if has_calcul .or. has_disfld
*   do clrsay
* endif
  do while .T.
    if modify_key
      do getkey
    endif
    do getfld
    read
    if readkey() = 12  && Esc
      * Esc key exits the loop without modifting the record
      abort = .T.
      exit
    endif
    if modify_key
      do chk_dupl
      if duplicate
        abort = .T.
        exit
      endif
    endif
    if has_lookup
      do lookup
    endif
    if has_calcul
      do calcul
    endif
    if has_calcul .or. has_disfld
      do disfld
    endif
    * Check for invalid entries
    do valdte
    if valid
      exit
    else
      if abort
        exit
      else
        loop
      endif
    endif
  enddo while .T.
  if .not. abort
    do save_rec with .F.    && save the modified record
  else
    go record_no
  endif
return

procedure pack_dbf
* Remove deleted records with user confirmation
  do while zoom_no < no_zooms
    zoom_no = zoom_no + 1
    zoom_num = str (zoom_no,1)
    if pack_it&zoom_num
      choice = 'N'
      do get_optn with 'Remove deleted records from ' + dbf_descr&zoom_num + ;
        ' (Y/N)', 'YN', choice
      if choice = 'Y'
        @ 23,00
        @ 23,00 say 'Packing, please wait'
        select &zoom_num
        pack
      endif
    endif
  enddo
return

procedure retrieve
* Accept key and seek record; if not found reposition to record_no
  if '' <> trim(ndx_var)
    do clrfld with .T.
    do getkey
    read
    if readkey() <> 12  && Esc
      seek trim(&ndx_var)
      if &at_eof
        do disp_msg with 'Not found'
        go record_no
      endif
    endif
  endif
return

procedure save_rec
parameters new_rec
* Edit memo field, if exists, and write current record to database file.
* If new_rec = .T. append a new record, otherwise, replace.
  if has_memo&zoom_num
    * Has a memo field: allow editing of memo field
    choice = 'N'
    do get_optn with 'Edit ' + memo_desc&zoom_num + ' (Y/N)', 'YN', choice
    if choice = 'Y'
      memo_field = memo_fld&zoom_num
      change next 1 field &memo_field
      redisp_scr = .T.
      go record_no
      do disscr
      do disp_rec
    endif
  endif
  choice = 'Y'
  do get_optn with 'Save (Y/N)','YN',choice
  if choice = 'N'
    abort = .T.
  else
    if new_rec
      append blank
      do replce
      if empty
        * Set boundaries
        skip -1
        if bof()
          top_mark = 0
        else
          top_mark = recno()
          skip 1
        endif
        skip 1
        if eof()
          bot_mark = -1
        else
          bot_mark = recno()
        endif
        skip -1
        empty = .F.
      endif empty
    else
      do replce
    endif new_rec
    if filter_on&zoom_num
      * Check if record matches filter
      record_no = recno()
      skip
      skip -1
      if recno() <> record_no
        * No match
        go top
        if &at_eof
          * Remove filter
          set filter to
          filter_on&zoom_num = .F.
          @ 0,70 say space(9)
          go record_no
        endif
      endif
    endif filter_on&zoom_num
  endif choice = 'Y'
return

procedure scr_box
parameters l_title, r_title
* Draw a screen box with left title "l_title" and right title "r_title"
  @ 1,0 to 22,79 double
  @ 3,1 to 3 ,78
  @ 2, 2 say trim(l_title)
  @ 2, 78-len(trim(r_title)) say trim(r_title)
return

procedure zoom
* Change zoom level
  * Assign parameters for new Zoom level
  zoom_num = str(zoom_no,1)
  at_bof = at_bof&zoom_num
  at_eof = at_eof&zoom_num
  filter_on&zoom_num = .F.
  first_page = val(substr(page_seq&zoom_num,1,1))
  ndx_var = ndx_var&zoom_num
  last_page = val(substr(page_seq&zoom_num,len(page_seq&zoom_num),1))
  * If a new page, display new screen
  if first_page <> page_no
    page_no = first_page
    redisp_scr = .F.
  endif
  * Select new Zoom area, set new top and bottom marks
  select &zoom_num
  record_no = recno()
  if zoom_no = 1
    top_mark = 0
    bot_mark = -1
  else
    lnk_var = lnk_var&zoom_num
    seek &lnk_var
    if .not. bof()
      skip -1
    endif
    if bof()
      top_mark = 0
    else
      top_mark = recno()
    endif
    if .not. eof()
      skip
    endif
    bot_mark = -2    && to be determined in procedure go_bot
  endif zoom_no = 1
return

* EOF REGISTER
